"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const request_promise_1 = __importDefault(require("request-promise"));
const rpscript_interface_1 = require("rpscript-interface");
/** Module for making http call
 * @see {@link https://www.npmjs.com/package/request-promise}
 * @namespace Request
 *
 * @example
 * rps install request
*/
let RPSRequest = class RPSRequest {
    /**
     * @function request
     * @memberof Request
     * @example
     * ; GET the content of google.com
     * request "http://www.google.com"
     *
     * @param {string} url url
     * @param {*} options refer to request-promise documentation.
     * @summary request :: String → String
     *
     * @see {@link https://www.npmjs.com/package/request-promise}
     *
    */
    request(ctx, opts, url) {
        return __awaiter(this, void 0, void 0, function* () {
            function req(url) {
                opts['uri'] = url;
                return request_promise_1.default(opts);
            }
            if (!url)
                return req;
            else
                return req(url);
        });
    }
};
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'request' })
], RPSRequest.prototype, "request", null);
RPSRequest = __decorate([
    rpscript_interface_1.RpsModule("request")
], RPSRequest);
exports.default = RPSRequest;
